<template>
  <ContentWrapper>
    <div class="content-heading">
      <div>
        {{bank.bank_id == 0 ? 'Registrar novo banco' : 'Atualizar banco - '+bank.bank_name}}
        <ol class="breadcrumb breadcrumb px-0 pb-0">
          <li class="breadcrumb-item">
            <a href="/banks" @click.prevent="$router.push({path:'/banks'})">Bancos</a>
          </li>
          <li class="breadcrumb-item active">{{bank.bank_id == 0 ? 'Registrar' : 'Atualizar'}}</li>
        </ol>
      </div>
    </div>
    <!-- LISTAGEM -->
    <div class="card">
      <div :class="'card-body'+(process.list ? ' whirl duo':'')">
        <!-- CADASTRO -->
        <form
          :class="(process.form ? ' whirl duo':'')"
          @submit.prevent="validateBeforeSubmit('bank')"
          data-vv-scope="bank"
        >
          <div class="card-body">
            <!-- NOME BANCO -->
            <div class="form-group row">
              <label class="col-md-3 col-form-label">Nome do banco*</label>
              <div class="col-md-9">
                <input
                  v-model="bank.bank_name"
                  v-validate="'required'"
                  :class="{'form-control':true, 'is-invalid': errors.has('bank.bank_name')}"
                  type="text"
                  name="bank_name"
                >
                <span
                  v-show="errors.has('bank.bank_name')"
                  class="invalid-feedback"
                >Informe o nome do banco</span>
              </div>
            </div>

            <!-- NUMERO DO BANCO -->
            <div class="form-group row">
              <label class="col-md-3 col-form-label">Número do banco*</label>
              <div class="col-md-9">
                <input
                  v-model="bank.bank_number"
                  v-validate="'required|numeric|is_not:0'"
                  :class="{'form-control':true, 'is-invalid': errors.has('bank.bank_number')}"
                  type="text"
                  name="bank_number"
                >
                <span
                  v-show="errors.has('bank.bank_number')"
                  class="invalid-feedback"
                >Informe o número do banco</span>
              </div>
            </div>
            <div style="color:red">* Campos requeridos</div>
          </div>
          <div class="text-right">
            <b-button
              class="mr-1 mb-1"
              type="submit"
              :variant="'success'"
            >{{(bank.bank_id == 0 ? 'Registrar' : 'Atualizar')}}</b-button>
          </div>
        </form>
      </div>
    </div>
  </ContentWrapper>
</template>
<script>
import Datatable from "@/components/Tables/Datatable";
import BankService from "@/domain/bank/BankService";

import Bank from "@/domain/bank/Bank";

import NotificationProvider from "@/provider/NotificationProvider";
import swal from "sweetalert2";

export default {
  name: "bank-form",
  components: {
    Datatable
  },
  created() {
    if (this.$route.params.id) {
      console.log("Buscando banco id " + this.$route.params.id);
      this.process.list = true;
      this.bankService
        .get(this.$route.params.id)
        .then(bank => {
          this.bank = bank;
          this.process.list = false;
        })
        .catch(err => {
          console.log(JSON.stringify(err));
          this.notificationProvider.error(
            "Falha na comunicação",
            "Não foi possível carregar o banco selecionado"
          );
        });
    }
  },
  data() {
    return {
      modalForm: false,
      process: {
        form: false,
        list: false
      },
      bank: new Bank(),
      bankService: new BankService(),
      banks: [],
      notificationProvider: new NotificationProvider(this.$notify),
      dtOptions: {
        paging: true, // Table pagination
        ordering: true, // Column ordering
        info: true, // Bottom left status text
        responsive: true,
        // Text translation options
        // Note the required keywords between underscores (e.g _MENU_)
        oLanguage: {
          sSearch: '<em class="fa fa-search"></em>',
          sLengthMenu: "_MENU_ registros por página",
          info: "Página _PAGE_ de _PAGES_",
          zeroRecords: "Nada encontrado",
          infoEmpty: "Nenhum registro",
          infoFiltered: "(Filtrado de _MAX_ itens)",
          oPaginate: {
            sNext: '<em class="fa fa-caret-right"></em>',
            sPrevious: '<em class="fa fa-caret-left"></em>'
          }
        },
        // Datatable key setup
        keys: false
      }
    };
  },
  methods: {
    validateBeforeSubmit(scope) {
      this.$validator.validateAll(scope).then(result => {
        if (result) {
          this.process.form = true;
          if (this.bank.bank_id == 0) {
            // CADASTRANDO
            this.bankService
              .create(this.bank)
              .then(response => {
                console.log("Banco criado");
                this.notificationProvider.success(
                  "Banco registrado!",
                  this.bank.bank_name + " registrado com sucesso"
                );
                this.$router.push({ path: "/banks" });
              })
              .catch(err => {
                console.log(JSON.stringify(err));
                if (
                  err.response &&
                  err.response.data &&
                  err.response.data.exception &&
                  err.response.data.exception ==
                    "Prettus\\Validator\\Exceptions\\ValidatorException"
                ) {
                  // alguma validação deu errado
                  for (var key in err.response.data.message) {
                    this.notificationProvider.error(
                      "Verificar " + key,
                      err.response.data.message[key][0]
                    );
                  }
                } else {
                  console.log(JSON.stringify(err));
                  this.notificationProvider.error(
                    "Falha ao registrar",
                    "Houve uma falha ao registrar o banco"
                  );
                }
                this.process.form = false;
              });
          } else {
            // EDITANDO
            this.bankService
              .update(this.bank.bank_id, this.bank)
              .then(response => {
                console.log("Banco atualizado");
                this.notificationProvider.success(
                  "Banco atualizado!",
                  this.bank.bank_name + " atualizado com sucesso"
                );
                this.$router.push({ path: "/banks" });
              })
              .catch(err => {
                console.log(JSON.stringify(err));
                if (
                  err.response &&
                  err.response.data &&
                  err.response.data.exception &&
                  err.response.data.exception ==
                    "Prettus\\Validator\\Exceptions\\ValidatorException"
                ) {
                  // alguma validação deu errado
                  for (var key in err.response.data.message) {
                    this.notificationProvider.error(
                      "Verificar " + key,
                      err.response.data.message[key][0]
                    );
                  }
                } else {
                  console.log(JSON.stringify(err));
                  this.notificationProvider.error(
                    "Falha ao registrar",
                    "Houve uma falha ao registrar o banco"
                  );
                }
                this.process.form = false;
              });
          }
        }
      });
    },
    remove(bank) {
      swal({
        title: "Deletar " + bank.bank_name + "?",
        text: "Não será possível recuperar!",
        type: "warning",
        showCancelButton: true,
        confirmButtonColor: "#DD6B55",
        confirmButtonText: "Sim, deletar!"
      }).then(result => {
        if (result.value) {
          this.bankService
            .delete(bank.bank_id)
            .then(response => {
              this.banks.forEach((el, index) => {
                if (bank.bank_id == el.bank_id) {
                  this.banks.splice(index, 1);
                }
              });
              this.notificationProvider.success(
                "Deletado",
                "Banco " + bank.bank_name + " deletado com sucesso!"
              );
            })
            .catch(err => {
              if (
                err.response &&
                err.response.data &&
                err.response.data.message &&
                err.response.data.message.indexOf(
                  "Integrity constraint violation"
                )
              ) {
                // erro de vinculo no banco
                this.notificationProvider.error(
                  "Não é possível remover",
                  "Existem registros vinculados a este registro"
                );
              } else {
                console.log(JSON.stringify(err));
                this.notificationProvider.error(
                  "Falha ao remover",
                  "Não foi possível remover este registro"
                );
              }
            });
        }
      });
    },
    add() {
      this.bank = new Bank();
      this.modalForm = false;
      this.modalForm = true;
    },
    edit(bk) {
      this.bank = new Bank(bk.bank_id, bk.bank_name, bk.bank_number);
      this.modalForm = false;
      this.modalForm = true;
    }
  }
};
</script>